"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");var _core=_interopRequireDefault(require("../../../../fusioncharts/core"));var _index=_interopRequireDefault(require("./index"));var _gantt=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/gantt.sanity"));var _ignoreCaseExt=_interopRequireDefault(require("../../../../fc-features/src/ignore-case-ext"));var _utility=require("../../../../../smoke-test/test-sanity/utility");var _lib=require("../../../../fc-core/src/lib/");var _common=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/common.sanity"));var chartData=_interopRequireWildcard(require("../../../../../smoke-test/test-data/data-by-chart"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}_core.default.addDep(_index.default);_core.default.addDep(_ignoreCaseExt.default);var svgElement,chartName=_index.default.getName(),chartID=chartName.toLowerCase(),doc=window.document;describe("Running common chart tests for "+chartName,(function(){var chart={type:chartID,renderAt:_utility.CONTAINER_ID,width:_utility.initDimensions.width,height:_utility.initDimensions.height,dataFormat:"json",dataSource:{}},config={chartID:chartID,chart:chart,document:doc,chartWrapperId:_utility.CONTAINER_ID};_common.default.forEach((function(test){var itArr;if(test.name&&test.run){it(test.name,(function(done){test.run(config,(function(result){expect(result).toBe(true);done()}))}))}else if(test.iterator){itArr=test.iterator(chart);itArr.forEach((function(subTest){it(subTest.name,(function(done){subTest.run(config,(function(result){expect(result).toBe(true);done()}))}))}))}}))}));describe("Chart basic testing: "+chartName,(function(){var chart,chartObj,itResize,renderData=_gantt.default.BASIC.newChart,updateData=_gantt.default.BASIC.updateChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Rendered chart validation passes",(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_gantt.default.BASIC.validate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.render();chartObj.addEventListener("renderComplete",renderComplete)}));it("Chart update passes",(function(done){expect(chartObj).toBeDefined();var called=0;var renderComplete=function renderComplete(){if(called===0){called++;chartObj.setChartData(updateData||chart.dataSource,"json")}else if(called===1){var response=_gantt.default.BASIC.updateValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));itResize=function itResize(resizeDimensions){it("Chart resize passes for "+resizeDimensions.width+" x "+resizeDimensions.height,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_gantt.default.BASIC.resizeValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render((function(){chartObj.resizeTo(resizeDimensions.width,resizeDimensions.height)}))}))};for(var index=0;index<_utility.resizeDimensions.length;index++){itResize(_utility.resizeDimensions[index])}}));describe("Chart EI testing: "+_index.default.getName(),(function(){var chart,chartObj,eiMethods,renderData=_gantt.default.EI.newChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));eiMethods=function eiMethods(methodObj){it(methodObj.name,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){svgElement=(0,_utility.getSVG)(chartObj);methodObj.fn(svgElement,chartObj,(function(result){expect(result).toBe(true);done()}))};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))};for(var key in _gantt.default.EI.methods){if(_gantt.default.EI.methods.hasOwnProperty(key)){eiMethods(_gantt.default.EI.methods[key])}}}));describe("Text outline testing "+chartName,(function(){var chart,chartObj,itResize,renderData={chart:{dateformat:"mm/dd/yyyy",outputdateformat:"hh:mn",caption:"Work Schedule",subcaption:"For next 2 days",textoutline:"1",showborder:"0"},categories:[{category:[{start:"7/15/2007 00:00:00",end:"7/15/2007 23:59:59",label:"Today"},{start:"7/16/2007 00:00:00",end:"7/16/2007 23:59:59",label:"Tomorrow"}]},{align:"right",category:[{start:"7/15/2007 00:00:00",end:"7/15/2007 05:59:59",label:"6 am"},{start:"7/15/2007 06:00:00",end:"7/15/2007 11:59:59",label:"12 pm"},{start:"7/15/2007 12:00:00",end:"7/15/2007 17:59:59",label:"6 pm"}]}],processes:{process:[{label:"John.S",id:"EMP121"},{label:"David.G",id:"EMP122"},{label:"Mary.P",id:"EMP123"}]},tasks:[{showlabels:"1",showstartdate:"1",task:[{processid:"EMP121",start:"7/15/2007 08:00:00",end:"7/15/2007 12:30:00",label:"Logo A"},{processid:"EMP121",start:"7/15/2007 17:00:00",end:"7/15/2007 19:30:00",label:"Logo B"},{processid:"EMP121",start:"7/16/2007 09:00:00",end:"7/16/2007 19:30:00",label:"Website template"}]}]},updateDataWithNoOutline={chart:{dateformat:"mm/dd/yyyy",outputdateformat:"hh:mn",caption:"Work Schedule",subcaption:"For next 2 days",showborder:"0"},categories:[{category:[{start:"7/15/2007 00:00:00",end:"7/15/2007 23:59:59",label:"Today"},{start:"7/16/2007 00:00:00",end:"7/16/2007 23:59:59",label:"Tomorrow"}]},{align:"right",category:[{start:"7/15/2007 00:00:00",end:"7/15/2007 05:59:59",label:"6 am"},{start:"7/15/2007 06:00:00",end:"7/15/2007 11:59:59",label:"12 pm"},{start:"7/15/2007 12:00:00",end:"7/15/2007 17:59:59",label:"6 pm"}]}],processes:{process:[{label:"John.S",id:"EMP121"},{label:"David.G",id:"EMP122"},{label:"Mary.P",id:"EMP123"}]},tasks:[{showlabels:"1",showstartdate:"1",task:[{processid:"EMP121",start:"7/15/2007 08:00:00",end:"7/15/2007 12:30:00",label:"Logo A"},{processid:"EMP121",start:"7/15/2007 17:00:00",end:"7/15/2007 19:30:00",label:"Logo B"},{processid:"EMP121",start:"7/16/2007 09:00:00",end:"7/16/2007 19:30:00",label:"Website template"}]}]};chart={type:chartID,renderAt:_utility.CONTAINER_ID,dataSource:renderData};beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Text outline should get applied",(function(done){var renderComplete=function renderComplete(){var labelElement=document.querySelector('[class$="datalabel').getElementsByTagName("text")[0];expect(labelElement.getAttribute("filter")).not.toBe(null);done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));it("Text outline should be removed",(function(done){var updateFlag=0,renderComplete=function renderComplete(){if(!updateFlag){updateFlag=1;chartObj.setJSONData(updateDataWithNoOutline)}else{var labelElement=document.querySelector('[class$="datalabel').getElementsByTagName("text")[0];expect(labelElement.getAttribute("filter")).toBe(null);done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))}));