"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");var _core=_interopRequireDefault(require("../../../../fusioncharts/core"));var _index=_interopRequireDefault(require("./index"));var _hlineargauge=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/hlineargauge.sanity"));var _ignoreCaseExt=_interopRequireDefault(require("../../../../fc-features/src/ignore-case-ext"));var _utility=require("../../../../../smoke-test/test-sanity/utility");var _lib=require("../../../../fc-core/src/lib/");var _common=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/common.sanity"));var chartData=_interopRequireWildcard(require("../../../../../smoke-test/test-data/data-by-chart"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}_core.default.addDep(_index.default);_core.default.addDep(_ignoreCaseExt.default);var svgElement,chartName=_index.default.getName(),chartID=chartName.toLowerCase(),doc=window.document;describe("Running common chart tests for "+chartName,(function(){var chart={type:chartID,renderAt:_utility.CONTAINER_ID,width:_utility.initDimensions.width,height:_utility.initDimensions.height,dataFormat:"json",dataSource:{}},config={chartID:chartID,chart:chart,document:doc,chartWrapperId:_utility.CONTAINER_ID};_common.default.forEach((function(test){var itArr;if(test.name&&test.run){it(test.name,(function(done){test.run(config,(function(result){expect(result).toBe(true);done()}))}))}else if(test.iterator){itArr=test.iterator(chart);itArr.forEach((function(subTest){it(subTest.name,(function(done){subTest.run(config,(function(result){expect(result).toBe(true);done()}))}))}))}}))}));describe("Chart basic testing: "+chartName,(function(){var chart,chartObj,itResize,renderData=_hlineargauge.default.BASIC.newChart,updateData=_hlineargauge.default.BASIC.updateChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Rendered chart validation passes",(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_hlineargauge.default.BASIC.validate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.render();chartObj.addEventListener("renderComplete",renderComplete)}));it("Chart update passes",(function(done){expect(chartObj).toBeDefined();var called=0;var renderComplete=function renderComplete(){if(called===0){called++;chartObj.setChartData(updateData||chart.dataSource,"json")}else if(called===1){var response=_hlineargauge.default.BASIC.updateValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));itResize=function itResize(resizeDimensions){it("Chart resize passes for "+resizeDimensions.width+" x "+resizeDimensions.height,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_hlineargauge.default.BASIC.resizeValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render((function(){chartObj.resizeTo(resizeDimensions.width,resizeDimensions.height)}))}))};for(var index=0;index<_utility.resizeDimensions.length;index++){itResize(_utility.resizeDimensions[index])}}));describe("Chart EI testing: "+_index.default.getName(),(function(){var chart,chartObj,eiMethods,renderData=_hlineargauge.default.EI.newChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));eiMethods=function eiMethods(methodObj){it(methodObj.name,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){svgElement=(0,_utility.getSVG)(chartObj);methodObj.fn(svgElement,chartObj,(function(result){expect(result).toBe(true);done()}))};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))};for(var key in _hlineargauge.default.EI.methods){if(_hlineargauge.default.EI.methods.hasOwnProperty(key)){eiMethods(_hlineargauge.default.EI.methods[key])}}}));describe("Text outline testing "+chartName,(function(){var chart,chartObj,itResize,renderData={chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",textoutline:"1",animation:"1"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{pointer:[{value:"92"}]}},updateDataWithNoOutline={chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",animation:"1"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{pointer:[{value:"92"}]}};chart={type:chartID,renderAt:_utility.CONTAINER_ID,dataSource:renderData};beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Text outline should get applied",(function(done){var renderComplete=function renderComplete(){var labelElement=document.querySelector('[class$="color-range-label"]').getElementsByTagName("text")[0];expect(labelElement.getAttribute("filter")).not.toBe(null);done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));it("Text outline should be removed",(function(done){var updateFlag=0,renderComplete=function renderComplete(){if(!updateFlag){updateFlag=1;chartObj.setJSONData(updateDataWithNoOutline)}else{var labelElement=document.querySelector('[class$="color-range-label"]').getElementsByTagName("text")[0];expect(labelElement.getAttribute("filter")).toBe(null);done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))}));describe("Test to reverse the chart through the property reverseScale",(function(){var chart,chartObj,renderData={chart:{animation:"0"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]}};chart={type:chartID,renderAt:_utility.CONTAINER_ID,dataSource:renderData};beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("When reverseScale is not enabled, max valued color range should be at the right side of scale",(function(done){var renderComplete=function renderComplete(){var scaleMaxValue=document.querySelectorAll('[class$="-dataset-top-label"]')[0].children[4];expect(Number(scaleMaxValue.getAttribute("x"))).toBe(chartObj.apiInstance.config.canvasRight);done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));it("When reverseScale is enabled, max valued color range should be at the left side of scale",(function(done){var updateFlag=0,renderComplete=function renderComplete(){if(!updateFlag){updateFlag=1;chartObj.setChartAttribute("reversescale",1)}else{var scaleMaxValue=document.querySelectorAll('[class$="-dataset-top-label"]')[0].children[4];expect(Number(scaleMaxValue.getAttribute("x"))).toBe(chartObj.apiInstance.config.canvasLeft);done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))}));describe("valueFontColor, valueBgColor, valueBorderColor",(function(){var chartObj;afterEach((function(){return chartObj.dispose()}));it("Chart should render properly without the attributes",(function(done){chartObj=(0,_utility.setup)(_core.default,{type:chartID,renderAt:_utility.CONTAINER_ID,width:600,height:350,dataSource:{chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",palette:"1",numbersuffix:"%",animation:"0"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{pointer:[{value:"92"}]}}});chartObj.addEventListener("renderComplete",(function(){var dataLabelsGroup=document.querySelectorAll('[class$="label-group"]')[0],rects=dataLabelsGroup.getElementsByTagName("rect"),texts=dataLabelsGroup.getElementsByTagName("text");expect(rects.length).toBe(0);expect(texts.length).toBe(1);expect(texts[0].getAttribute("fill")).toBe("#555555");done()}));chartObj.render()}));it("Pointer label should take the value cosmetics from chart level",(function(done){chartObj=(0,_utility.setup)(_core.default,{type:chartID,renderAt:_utility.CONTAINER_ID,width:600,height:350,dataSource:{chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",palette:"1",numbersuffix:"%",valuefontcolor:"ff0000",valuebgcolor:"ffffff",valuebordercolor:"000000",animation:"0"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{pointer:[{value:"92"}]}}});chartObj.addEventListener("renderComplete",(function(){var dataLabelsGroup=document.querySelectorAll('[class$="label-group"]')[0],rects=dataLabelsGroup.getElementsByTagName("rect"),texts=dataLabelsGroup.getElementsByTagName("text");expect(rects.length).toBe(1);expect(texts.length).toBe(1);expect(texts[0].getAttribute("fill")).toBe("#ff0000");expect(rects[0].getAttribute("stroke")).toBe("#000000");expect(rects[0].getAttribute("fill")).toBe("#ffffff");done()}));chartObj.render()}));it("Pointer label should take the value cosmetics from pointers level",(function(done){chartObj=(0,_utility.setup)(_core.default,{type:chartID,renderAt:_utility.CONTAINER_ID,width:600,height:350,dataSource:{chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",palette:"1",numbersuffix:"%",valuefontcolor:"ff0000",valuebgcolor:"ffffff",valuebordercolor:"000000",animation:"0"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{valuefontcolor:"00ff00",valuebgcolor:"0000ff",valuebordercolor:"ff0000",pointer:[{value:"92"}]}}});chartObj.addEventListener("renderComplete",(function(){var dataLabelsGroup=document.querySelectorAll('[class$="label-group"]')[0],rects=dataLabelsGroup.getElementsByTagName("rect"),texts=dataLabelsGroup.getElementsByTagName("text");expect(rects.length).toBe(1);expect(texts.length).toBe(1);expect(texts[0].getAttribute("fill")).toBe("#00ff00");expect(rects[0].getAttribute("stroke")).toBe("#ff0000");expect(rects[0].getAttribute("fill")).toBe("#0000ff");done()}));chartObj.render()}));it("Pointer label should take the value cosmetics from pointer level",(function(done){chartObj=(0,_utility.setup)(_core.default,{type:chartID,renderAt:_utility.CONTAINER_ID,width:600,height:350,dataSource:{chart:{lowerlimit:"0",upperlimit:"100",lowerlimitdisplay:"Bad",upperlimitdisplay:"Good",palette:"1",numbersuffix:"%",valuefontcolor:"ff0000",valuebgcolor:"ffffff",valuebordercolor:"000000",animation:"0"},colorrange:{color:[{minvalue:"0",maxvalue:"75",code:"FF654F",label:"Bad"},{minvalue:"75",maxvalue:"90",code:"F6BD0F",label:"Moderate"},{minvalue:"90",maxvalue:"100",code:"8BBA00",label:"Good"}]},pointers:{valuefontcolor:"00ff00",valuebgcolor:"0000ff",valuebordercolor:"ff0000",pointer:[{value:"92",valuefontcolor:"fff000",valuebgcolor:"ff0000",valuebordercolor:"00ff00"}]}}});chartObj.addEventListener("renderComplete",(function(){var dataLabelsGroup=document.querySelectorAll('[class$="label-group"]')[0],rects=dataLabelsGroup.getElementsByTagName("rect"),texts=dataLabelsGroup.getElementsByTagName("text");expect(rects.length).toBe(1);expect(texts.length).toBe(1);expect(texts[0].getAttribute("fill")).toBe("#fff000");expect(rects[0].getAttribute("stroke")).toBe("#00ff00");expect(rects[0].getAttribute("fill")).toBe("#ff0000");done()}));chartObj.render()}))}));