"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");var _core=_interopRequireDefault(require("../../../../fusioncharts/core"));var _index=_interopRequireDefault(require("./index"));var _vbullet=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/vbullet.sanity"));var _ignoreCaseExt=_interopRequireDefault(require("../../../../fc-features/src/ignore-case-ext"));var _utility=require("../../../../../smoke-test/test-sanity/utility");var _lib=require("../../../../fc-core/src/lib/");var _common=_interopRequireDefault(require("../../../../../smoke-test/test-sanity/common.sanity"));var chartData=_interopRequireWildcard(require("../../../../../smoke-test/test-data/data-by-chart"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}_core.default.addDep(_index.default);_core.default.addDep(_ignoreCaseExt.default);var svgElement,chartName=_index.default.getName(),chartID=chartName.toLowerCase(),doc=window.document;describe("Running common chart tests for "+chartName,(function(){var chart={type:chartID,renderAt:_utility.CONTAINER_ID,width:_utility.initDimensions.width,height:_utility.initDimensions.height,dataFormat:"json",dataSource:{}},config={chartID:chartID,chart:chart,document:doc,chartWrapperId:_utility.CONTAINER_ID};_common.default.forEach((function(test){var itArr;if(test.name&&test.run){it(test.name,(function(done){test.run(config,(function(result){expect(result).toBe(true);done()}))}))}else if(test.iterator){itArr=test.iterator(chart);itArr.forEach((function(subTest){it(subTest.name,(function(done){subTest.run(config,(function(result){expect(result).toBe(true);done()}))}))}))}}))}));describe("Chart basic testing: "+chartName,(function(){var chart,chartObj,itResize,renderData=_vbullet.default.BASIC.newChart,updateData=_vbullet.default.BASIC.updateChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Rendered chart validation passes",(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_vbullet.default.BASIC.validate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.render();chartObj.addEventListener("renderComplete",renderComplete)}));it("Chart update passes",(function(done){expect(chartObj).toBeDefined();var called=0;var renderComplete=function renderComplete(){if(called===0){called++;chartObj.setChartData(updateData||chart.dataSource,"json")}else if(called===1){var response=_vbullet.default.BASIC.updateValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()}};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}));itResize=function itResize(resizeDimensions){it("Chart resize passes for "+resizeDimensions.width+" x "+resizeDimensions.height,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){var response=_vbullet.default.BASIC.resizeValidate(chartObj);expect(response.flag).toBe(true,response.messages.join(" && "));done()};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render((function(){chartObj.resizeTo(resizeDimensions.width,resizeDimensions.height)}))}))};for(var index=0;index<_utility.resizeDimensions.length;index++){itResize(_utility.resizeDimensions[index])}}));describe("Chart EI testing: "+_index.default.getName(),(function(){var chart,chartObj,eiMethods,renderData=_vbullet.default.EI.newChart;chart={type:chartID,renderAt:_utility.CONTAINER_ID};(0,_lib.extend2)(chart,renderData);chart.dataSource=chart.dataSource?chart.dataSource:chartData[chartID]["default"];chart.dataSource.chart.animation="0";beforeEach((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterEach((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));eiMethods=function eiMethods(methodObj){it(methodObj.name,(function(done){expect(chartObj).toBeDefined();var renderComplete=function renderComplete(){svgElement=(0,_utility.getSVG)(chartObj);methodObj.fn(svgElement,chartObj,(function(result){expect(result).toBe(true);done()}))};chartObj.addEventListener("renderComplete",renderComplete);chartObj.render()}))};for(var key in _vbullet.default.EI.methods){if(_vbullet.default.EI.methods.hasOwnProperty(key)){eiMethods(_vbullet.default.EI.methods[key])}}}));describe("Scale position testing",(function(){var chartObj,data={chart:{lowerlimit:"0",upperlimit:"100",caption:"Revenue",subcaption:"US $ (1,000s)",numberprefix:"$",numbersuffix:"K",showvalue:"1",animation:"0",scaleposition:"right"},colorrange:{color:[{minvalue:"0",maxvalue:"50",color:"A6A6A6"},{minvalue:"50",maxvalue:"75",color:"CCCCCC"},{minvalue:"75",maxvalue:"100",color:"E1E1E1"}]},value:"78.9",target:"80"},chart={type:chartID,renderAt:_utility.CONTAINER_ID,width:600,height:400,dataFormat:"json",dataSource:data};beforeAll((function(){chartObj=(0,_utility.setup)(_core.default,chart)}));afterAll((function(){if(chartObj&&!chartObj.disposed)chartObj.dispose()}));it("Scale will be rendered on right",(function(done){chartObj.addEventListener("renderComplete",(function(e){e.detachHandler();var dim=chartObj.apiInstance.getChildren("scale")[0].config.axisDimention,scaleLabelsGroup=document.querySelectorAll('[class*="axistop"] > [class*="dataset-Label-group"]')[0],label=scaleLabelsGroup.getElementsByTagName("text")[0];expect(dim.x).toBe(541);expect(label.getAttribute("x")).toBe("552");done()}));chartObj.render()}));it("Scale will be updated to render on left",(function(done){chartObj.addEventListener("renderComplete",(function(e){e.detachHandler();var dim=chartObj.apiInstance.getChildren("scale")[0].config.axisDimention,scaleLabelsGroup=document.querySelectorAll('[class*="axistop"] > [class*="dataset-Label-group"]')[0],label=scaleLabelsGroup.getElementsByTagName("text")[0];expect(dim.x).toBe(59);expect(label.getAttribute("x")).toBe("48");done()}));data.chart.scaleposition=undefined;chartObj.setJSONData(data)}));it("Scale will be updated to render on right with depricated attribute ticksOnRight",(function(done){chartObj.addEventListener("renderComplete",(function(e){e.detachHandler();var dim=chartObj.apiInstance.getChildren("scale")[0].config.axisDimention,scaleLabelsGroup=document.querySelectorAll('[class*="axistop"] > [class*="dataset-Label-group"]')[0],label=scaleLabelsGroup.getElementsByTagName("text")[0];expect(dim.x).toBe(541);expect(label.getAttribute("x")).toBe("552");done()}));data.chart.ticksOnRight=1;chartObj.setJSONData(data)}));it("Scale will be updated to render on left since scalePosition has higher priority",(function(done){chartObj.addEventListener("renderComplete",(function(e){e.detachHandler();var dim=chartObj.apiInstance.getChildren("scale")[0].config.axisDimention,scaleLabelsGroup=document.querySelectorAll('[class*="axistop"] > [class*="dataset-Label-group"]')[0],label=scaleLabelsGroup.getElementsByTagName("text")[0];expect(dim.x).toBe(59);expect(label.getAttribute("x")).toBe("48");done()}));data.chart.scaleposition="left";chartObj.setJSONData(data)}))}));